diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach v15.63/pop/src/ass.p v15.6301-amd64/pop/src/ass.p
--- v15.63/pop/src/ass.p	1996-09-30 08:33:01.000000000 -0400
+++ v15.6301-amd64/pop/src/ass.p	2009-12-26 17:40:45.000000000 -0500
@@ -64,7 +64,8 @@
 section $-Sys$-Vm;
 
 lvars
-	_strsize,			;;; size of structure table in bytes
+      _regmask,
+      _strsize, ;;; size of structure table in bytes
 ;
 
 
@@ -81,6 +82,13 @@
 
 	_WORD	= _16:66,			;;; 16-bit operand size
 
+        _REX_W  = _16:48,                       ;;; 64-bit operand size
+        _REX_R  = _16:4,
+        _REX_X  = _16:2,
+        _REX_B  = _16:1,
+
+        _NO_REX_W  = _16:1000,
+
 	;;; Opcode bytes
 
 	_ADD	= _16:01,
@@ -93,19 +101,24 @@
 	_JMP	= _16:E9,			;;; jump EIP-relative
 	_LEA	= _16:8D,
 	_MOV	= _16:89,			;;; standard R/M -> R/M move
+        _MOV32  = _MOV _biset _NO_REX_W,
 	_MOVI	= _16:C7,			;;; move Imm -> R/M
 	_MOVIs	= _16:B8,			;;; short (1-byte) Imm -> Reg move
+        _MOVSXD = _16:63,                       ;;; 32->64 bit sign-extend
+        _MOVZXD = _MOVSXD _biset _NO_REX_W,         ;;;  zero extend
 	_MOVX	= _16:0F,			;;; move and extend (followed by SX or ZX)
-	_MOVSX	= _16:BF,			;;; move and sign-extend R/M-16 -> Reg32
-	_MOVZX	= _16:B7,			;;; move and zero-extend R/M-16 -> Reg32
+	_MOVSX	= _16:BF _biset  _NO_REX_W,	;;; move and sign-extend R/M-16 -> Reg32
+	_MOVZX	= _16:B7 _biset  _NO_REX_W,	;;; move and zero-extend R/M-16 -> Reg32
 	_NOP	= _16:90,
 	_POP	= _16:8F,
+        _POPs   = _16:58,   ;;; short (1-byte) form
 	_PUSH	= _16:FF,
 	_PUSHI	= _16:68,
-	_PUSHs	= _16:50,			;;; short (1-byte) form
+	_PUSHs	= _16:50,	;;; short (1-byte) form
 	_RET	= _16:C3,
 	_SHIFTI = _16:C1,			;;; shift/rotate by imm8 (modified by TTT)
 	_SUB	= _16:29,
+        _TEST   = _16:85,
 	_TESTI	= _16:F7,			;;; test Imm -> R/M
 	_TESTIs	= _16:A9,			;;; test Imm -> EAX
 	_XCHG	= _16:87,
@@ -116,6 +129,7 @@
 	_CALL	= _2:010,
 	_CHAIN	= _2:100,			;;; i.e. indirect jump
 	_CMPI	= _2:111,
+        _SAL    = _2:100,
 	_SAR	= _2:111,
 	_SUBI	= _2:101,
 
@@ -151,6 +165,15 @@
 	_ESI	= _2:110,
 	_EDI	= _2:111,
 
+        _R8     = _2:1000,
+        _R9     = _2:1001,
+        _R10    = _2:1010,
+        _R11    = _2:1011,
+        _R12    = _2:1100,
+        _R13    = _2:1101,
+        _R14    = _2:1110,
+        _R15    = _2:1111,
+
 	_reg_SIB	= _2:100,		;;; escape to 2-byte form
 	_reg_ABS	= _2:101,		;;; no register: absolute 32-bit address
 
@@ -189,7 +212,7 @@
 	;;; NAMED REGISTERS
 
 	_SP		= _ESP,				;;; system stack pointer
-	_USP	= _EBX,				;;; user stack pointer
+	_USP	        = _EBX,				;;; user stack pointer
 	_PB		= _EBP,				;;; procedure base register
 
 	_ARG_REG_0	= _EAX,			;;; for arguments to subroutines
@@ -207,6 +230,7 @@
 	;;; (available to the VM)
 
 	;;; The value is a popint register number shifted left 1
+        ;;; plus bit 0 if pop reg
 
 	;;; arg_reg_0, _1, & _2 :
 	;;; for passing arguments to subroutines. _1 & _2 are (currently) used
@@ -222,23 +246,41 @@
 
 	chain_reg	= _pint(_CHAIN_REG) << 1,		;;; EDX
 
+        pop_reg_A     = _pint(_R13) <<1 || 1,
+        pop_reg_B     = _pint(_R14) <<1 || 1,
+        pop_reg_C     = _pint(_R15) <<1 || 1,
+        nonpop_reg_A = _pint(_R8) <<1,
+        nonpop_reg_B = _pint(_R10) <<1,
+        nonpop_reg_C = _pint(_R11) <<1,
+        nonpop_reg_D = _pint(_R12) <<1,
+
 ;
 
 constant
 
 	;;; REGISTER LVARS
-	;;; (there aren't any!)
 
-	asm_pop_registers		= [[]],
-	asm_nonpop_registers	= [[]],
+        asm_pop_registers = [[]],
 
+        asm_nonpop_registers = [[]],
+
+/*
+
+        asm_pop_registers = [%[], ident pop_reg_A, ident pop_reg_B,
+                                  ident pop_reg_C %],
+        asm_nonpop_registers = [%[], ident nonpop_reg_A, ident nonpop_reg_B,
+                                 ident nonpop_reg_C, ident nonpop_reg_D %],
+
+        asm_nonpop_registers = [%[], ident nonpop_reg_A, ident nonpop_reg_D %],
+*/
 ;
 
+
 lvars
 	_USP_offset,	;;; "static offset" for accumulating adjustments to USP
 ;
 
-lconstant procedure flush_USP_offset;	;;; forward reference
+constant procedure flush_USP_offset;	;;; forward reference
 
 define Is_address_reg() with_nargs 1;
 	Is_register()			;;; every reg is an address reg
@@ -247,13 +289,16 @@
 
 ;;; === CODE-PLANTING PROCEDURES ======================================
 
-;;; Drop_b, Drop_w, Drop_l:
-;;;		put a byte/word/longword in the procedure record
+;;; Drop_b, Drop_w, Drop_l, Drop_d:
+;;;		put a byte/word/longword/quadword in the procedure record
 
 define Drop_b(_byte);
 	lvars _byte;
 	unless _asm_pass then
 		;;; only output the data on the last pass
+;;;                _extern printf('Drop_b(0x%02x)\n', _byte);
+;;;                _extern printf('%c', _byte);
+;;;                _extern fflush (_0);
 		_byte -> _asm_drop_ptr!(b)++ -> _asm_drop_ptr;
 	endunless;
 	@@(b){_asm_code_offset}++ -> _asm_code_offset;
@@ -261,8 +306,14 @@
 
 define Drop_w(_word);
 	lvars _word;
+;;;        lvars _pword = _word;
 	unless _asm_pass then
 		;;; only output the data on the last pass
+;;;                _extern printf('Drop_w(0x%04x)\n', _word);
+;;;                _extern printf('%c', _pword);
+;;;                _shift(_pword, _-8) - > _pword;
+;;;                _extern printf('%c', _pword);
+;;;                _extern fflush (_0);
 		_word -> _asm_drop_ptr!(s)++ -> _asm_drop_ptr;
 	endunless;
 	@@(s){_asm_code_offset}++ -> _asm_code_offset;
@@ -270,23 +321,102 @@
 
 define Drop_l(_long);
 	lvars _long;
+;;;     lvars _pword = _long;
 	unless _asm_pass then
 		;;; only output the data on the last pass
-		_long -> _asm_drop_ptr!(l)++ -> _asm_drop_ptr;
+;;;                _extern printf('Drop_l(0x%08x)\n', _long);
+#_IF false
+                _extern printf('%c', _pword);
+                _shift(_pword, _-8) - > _pword;
+                _extern printf('%c', _pword);
+                _shift(_pword, _-8) - > _pword;
+                _extern printf('%c', _pword);
+                _shift(_pword, _-8) - > _pword;
+                _extern printf('%c', _pword);
+                _extern fflush (_0);
+#_ENDIF
+		_long -> _asm_drop_ptr!(i)++ -> _asm_drop_ptr;
 	endunless;
-	@@(l){_asm_code_offset}++ -> _asm_code_offset;
+	@@(i){_asm_code_offset}++ -> _asm_code_offset;
 enddefine;
 
+
+define Drop_d(_double);
+        lvars _double;
+        unless _asm_pass then
+                ;;; only output the data on the last pass
+                _double -> _asm_drop_ptr!(l)++ -> _asm_drop_ptr;
+        endunless;
+        @@(l){_asm_code_offset}++ -> _asm_code_offset;
+enddefine;
+
+define constant Get_rex_sib(_rr, _rx, _rb);
+   lvars _rr, _rx, _rb, _rex = _REX_W;
+   if _rr _greq _R8 then
+;;;      _rr _sub _R8 -> _rr;
+      _rex _add _REX_R -> _rex;
+   endif;
+   if _rx _greq _R8 then
+;;;      _rx _bimask _7 -> _rb;
+      _rex _add _REX_X -> _rex;
+   endif;
+   if _rb _greq _R8 then
+;;;      _rb _sub _R8 -> _rb;
+      _rex _add _REX_B -> _rex;
+   endif;
+   _rex
+enddefine;
+
+define constant Get_rex_rm(_rr, _rm);
+  Get_rex_sib(_rr, _EAX, _rm);
+enddefine;
+
+define constant Get_rex_short(_reg);
+  Get_rex_sib(_EAX, _EAX, _reg);
+enddefine;
+
+define constant is_large_int(_src);
+  lvars src;
+    if _src _slt _-2147483648 or _src _sgr 2147483647 then
+      true
+    else
+      false
+    endif
+enddefine;
+
+
 ;;; Drop_short:
 ;;;		output a short (1-byte) instruction, with format:
 
 ;;;			[opcode|reg]
 ;;;			   5     3
 
-define lconstant Drop_short(/* _opcode, _reg */) with_nargs 2;
-	Drop_b(nonop _add(/* _opcode, _reg */));
+define constant Drop_short( _opcode, _reg ) with_nargs 2;
+        lvars _opcode, _reg, _rex = Get_rex_short(_reg);
+        _reg _bimask _7 -> _reg;
+        if _not(_opcode == _PUSHs or _opcode == _POPs) or _rex /== _REX_W then
+            Drop_b(_rex);
+        endif;
+	Drop_b(_opcode _add _reg);
+enddefine;
+
+define constant Drop_rex(_opcode, _rex) -> _opcode;
+  lvars _opcode, _rex;
+        if (_opcode == _MOVSX  or _opcode == _MOVZX)
+              and _rex /== _REX_W then
+          mishap(0, 'Drop_rex: MOV[SZ]X CAN NOT USE EXTENDED REGISTERS');
+        endif;
+        if _opcode _bitst _NO_REX_W then
+          if _rex /== _REX_W then
+            Drop_b(_rex _sub _8);
+          endif;
+          _opcode _sub _NO_REX_W -> _opcode;
+        elseif _opcode /== _BR_IND or _rex /== _REX_W then
+          Drop_b(_rex);
+        endif;
 enddefine;
 
+
 ;;; Drop_std:
 ;;;		output a "standard" instruction, with format:
 
@@ -296,20 +426,33 @@
 ;;; 	Also handles system stack indirections, which should be of this form
 ;;;		but need an extra SIB byte.
 
-define lconstant Drop_std(/* _opcode, */ _reg, _mod, _rm, _disp) with_nargs 5;
-	lvars _reg, _mod, _rm, _disp;
-	Drop_b(/* _opcode */);
-	Drop_b(_mod _add _shift(_reg, _3) _add _rm);
-	if _rm == _ESP and _mod /== _REG then
+define constant Drop_std(_opcode, _reg, _mod, _rm, _disp) with_nargs 5;
+	lvars _reg, _mod, _rm, _disp, _rex = Get_rex_rm(_reg, _rm);
+        _reg _bimask _7 -> _reg;
+        _rm _bimask _7 -> _rm;
+        if is_large_int(_disp) then
+          mishap(0, 'Drop_std: DISPLACEMENT TOO BIG FOR 32-BITS');
+        endif;
+        Drop_rex(_opcode, _rex) -> _opcode;
+	Drop_b( _opcode);
+        if _mod == _ABS and _rm == _reg_ABS then
+                ;;; amd64 supports SIB form,
+                ;;; rm variant means RIP relative addressing
+            Drop_b(_mod _add _shift(_reg, _3) _add _reg_SIB);
+            Drop_b(_NOINDEX _add _reg_ABS);
+            Drop_l(_disp);
+        else
+	    Drop_b(_mod _add _shift(_reg, _3) _add _rm);
+
+	    if _rm == _ESP and _mod /== _REG then
 		;;; stack references need an extra byte
 		Drop_b(_NOINDEX _add _ESP);
-	endif;
-	if _mod == _DISP32
-	or _mod == _ABS and _rm == _reg_ABS
-	then
+	    endif;
+            if _mod == _DISP32 then
 		Drop_l(_disp);
-	elseif _mod == _DISP8 then
+	    elseif _mod == _DISP8 then
 		Drop_b(_disp);
+            endif;
 	endif;
 enddefine;
 
@@ -319,9 +462,18 @@
 ;;;			[opcode] [mod|reg|2:100] [s|index|base] [displacement]
 ;;;			   8            8              8            0/8/32
 
-define lconstant Drop_extd(/* _opcode, */ _reg, _mod, _base, _disp, _index, _s) with_nargs 7;
-	lvars _reg, _mod, _base, _disp, _index, _s;
-	Drop_b(/* _opcode */);
+define constant Drop_extd( _opcode, _reg, _mod, _base, _disp, _index, _s) with_nargs 7;
+	lvars _reg, _mod, _base, _disp, _index, _s,
+              _rex = Get_rex_sib(_reg, _index, _base);
+        _reg _bimask _7 -> _reg;
+        _index _bimask _7 -> _index;
+        _base _bimask _7 -> _base;
+
+        if is_large_int(_disp) then
+          mishap(0, 'Drop_extd: DISPLACEMENT TOO BIG FOR 32-BITS');
+        endif;
+        Drop_rex(_opcode, _rex) -> _opcode;
+	Drop_b(_opcode);
 	Drop_b(_mod _add _shift(_reg, _3) _add _reg_SIB);
 	Drop_b(_s _add _shift(_index, _3) _add _base);
 	if _mod == _DISP32
@@ -342,8 +494,11 @@
 ;;; 	The opcode given may be adjusted by having its SBIT set when
 ;;;		the immediate value can be represented in 8 bits.
 
-define lconstant Drop_imm(_opcode, _ttt, _imm, _mod, _rm, _disp);
+define constant Drop_imm(_opcode, _ttt, _imm, _mod, _rm, _disp);
 	lvars _opcode, _ttt, _imm, _mod, _rm, _disp;
+        if is_large_int(_imm) then
+           mishap(0, 'Drop_imm: IMMEDIATE TOO BIG FOR 32-BITS');
+        endif;
 	if _-128 _slteq _imm and _imm _slteq _127 then
 		Drop_std(_opcode _biset _SBIT, _ttt, _mod, _rm, _disp), Drop_b(_imm);
 	else
@@ -351,38 +506,62 @@
 	endif;
 enddefine;
 
+;;; define Drop_imm_to_r9(_imm);
+;;;    lvars _imm;
+;;;                Drop_b(_16:49);
+;;;                Drop_b(_16:B9);
+;;;                Drop_d(_imm);
+;;; enddefine;
+
 ;;; Drop_move_imm:
 ;;;		plant an immediate move, which doesn't fit the above format!
 
-define lconstant Drop_move_imm(_imm, _mod, _rm, _disp);
+define constant Drop_move_imm(_imm, _mod, _rm, _disp);
 	lvars _imm, _mod, _rm, _disp;
 	if _mod == _REG then
 		;;; use a short form of MOV
 		Drop_short(_MOVIs, _rm);
-	else
+                Drop_d(_imm);
+	else if _-2147483648 _slteq _imm and _imm _slteq _2147483647 then
 		Drop_std(_MOVI, _0, _mod, _rm, _disp);
+                Drop_l(_imm);
+             else
+                ;;; moveq imm, %r9
+                Drop_move_imm(_imm, _REG, _R9, false);
+;;;                Drop_b(_16:49);
+;;;                Drop_b(_16:B9);
+;;;                Drop_d(_imm);
+                Drop_std(_MOV, _R9, _mod, _rm, _disp);
+                ;;; mishap(0, 'IMMEDIATE TOO BIG FOR 32-BISTS');
+             endif;
 	endif;
-	Drop_l(_imm);
 enddefine;
 
 ;;; Drop_test_imm:
 ;;; 	plant test against immediate value (different format again)
 
-define lconstant Drop_test_imm(_imm, _mod, _rm, _disp);
-	if _mod == _REG and _rm == _EAX then
-		;;; short form
-		Drop_b(_TESTIs);
-	else
-		Drop_std(_TESTI, _0, (_mod, _rm, _disp));
-	endif;
-	Drop_l(_imm);
+define constant Drop_test_imm(_imm, _mod, _rm, _disp);
+    lvars _imm, _mod, _rm, _disp;
+    if _-2147483648 _slteq _imm and _imm _slteq _2147483647 then
+        if _mod == _REG and _rm == _EAX then
+            ;;; short form
+            Drop_b(_REX_W);
+            Drop_b(_TESTIs);
+        else
+            Drop_std(_TESTI, _0, (_mod, _rm, _disp));
+        endif;
+        Drop_l(_imm);
+    else
+        Drop_move_imm(_imm, _REG, _R9, false);
+        Drop_std(_TEST, _R9, _mod, _rm, _disp);
+    endif;
 enddefine;
 
 ;;;	Drop_call_indir:
 ;;;		plant an indirect subroutine call: the target is the absolute
 ;;;		address at the given effective address.
 
-define lconstant Drop_call_indir(_mod, _rm, _disp);
+define constant Drop_call_indir(_mod, _rm, _disp);
 	lvars _mod, _rm, _disp;
 	flush_USP_offset();
 	Drop_std(_BR_IND, _CALL, _mod, _rm, _disp);
@@ -394,7 +573,7 @@
 ;;;		This can't be done directly: the address must be loaded to _CALLREG
 ;;;		and the call done indirect via that.
 
-define lconstant Drop_call_or_chain_abs(_routine, _mode);
+define constant Drop_call_or_chain_abs(_routine, _mode);
 	lvars _routine, _mode;
 	;;; Align the user stack
 	flush_USP_offset();
@@ -404,11 +583,11 @@
 	Drop_std(_BR_IND, _mode, (_REG, _CALLREG, false));
 enddefine;
 
-define lconstant Drop_call_abs(/* _routine */) with_nargs 1;
+define constant Drop_call_abs(/* _routine */) with_nargs 1;
 	Drop_call_or_chain_abs(/* _routine, */ _CALL);
 enddefine;
 
-define lconstant Drop_chain_abs(/* _routine */) with_nargs 1;
+define constant Drop_chain_abs(/* _routine */) with_nargs 1;
 	Drop_call_or_chain_abs(/* _routine, */ _CHAIN);
 enddefine;
 
@@ -420,7 +599,7 @@
 ;;; Get_imm_efa:
 ;;;		the effective address of an immediate operand
 
-define lconstant Get_imm_efa(_imm);
+define constant Get_imm_efa(_imm);
 	lvars _imm;
 	(_IMM, false, _imm);
 enddefine;
@@ -428,7 +607,7 @@
 ;;; Get_abs_efa:
 ;;;		the effective address of an absolute operand
 
-define lconstant Get_abs_efa(_addr);
+define constant Get_abs_efa(_addr);
 	lvars _addr;
 	(_ABS, _reg_ABS, _addr);
 enddefine;
@@ -436,7 +615,7 @@
 ;;; Get_reg_efa:
 ;;;		the effective address of a register operand
 
-define lconstant Get_reg_efa(_reg);
+define constant Get_reg_efa(_reg);
 	lvars _reg;
 	(_REG, _reg, false);
 enddefine;
@@ -444,7 +623,7 @@
 ;;; Get_regindir_efa:
 ;;;		the effective address of a register-indirect operand
 
-define lconstant Get_regindir_efa(_reg, _disp);
+define constant Get_regindir_efa(_reg, _disp);
 	lvars _reg, _disp;
 	if _zero(_disp) and _reg /== _EBP then
 		_DISP0
@@ -462,7 +641,7 @@
 ;;;		intermediate load; if -defer- is <false>, the result is an ordinary
 ;;;		register-indirect efa.
 
-define lconstant Get_regdindir_efa(_reg, _disp, defer, _tmp_reg);
+define constant Get_regdindir_efa(_reg, _disp, defer, _tmp_reg);
 	lvars _reg, _disp, defer, _tmp_reg;
 	if defer then
 		;;; movl [disp](%reg), %tmp_reg
@@ -480,7 +659,7 @@
 ;;;		_tmp_reg is a register to use if a dereference requires an extra
 ;;;		load.
 
-define lconstant Get_structure_efa(_arg, defer, _tmp_reg);
+define constant Get_structure_efa(_arg, defer, _tmp_reg);
 	lvars structure, defer, _arg, _tmp_reg, _reg;
 	asm_instr!INST_ARGS[_arg] -> structure;
 	if iscompound(structure) and structure >=@(w) _system_end then
@@ -517,21 +696,21 @@
 
 ;;; Effective addresses for user-stack operands:
 
-define lconstant Get_upush_efa();
-	--@@(w){_USP_offset} -> _USP_offset;
+define constant Get_upush_efa();
+	--@@(l){_USP_offset} -> _USP_offset;
 	Get_regindir_efa(_USP, _USP_offset);
 enddefine;
 
-define lconstant Get_upop_efa();
+define constant Get_upop_efa();
 	Get_regindir_efa(_USP, _USP_offset);
-	@@(w){_USP_offset}++ -> _USP_offset;
+	@@(l){_USP_offset}++ -> _USP_offset;
 enddefine;
 
-define lconstant Get_utop_efa();
+define constant Get_utop_efa();
 	Get_regindir_efa(_USP, _USP_offset);
 enddefine;
 
-define lconstant Get_usubscr_efa(_i);
+define constant Get_usubscr_efa(_i);
 	lvars _i;
 	Get_regindir_efa(_USP, _USP_offset _add @@(w)[_i]);
 enddefine;
@@ -540,7 +719,7 @@
 ;;;		adjust the userstack pointer to account for any accumulated static
 ;;;		offset.
 
-define lconstant flush_USP_offset();
+define constant flush_USP_offset();
 	unless _zero(_USP_offset) then
 		;;; leal [_USP_offset](%USP), %USP
 		Drop_std(_LEA, _USP, Get_utop_efa());
@@ -559,7 +738,7 @@
 ;;;		If there's no explicit destination, a push on the user stack is
 ;;;		assumed.
 
-define lconstant Get_dst_efa();
+define constant Get_dst_efa();
 	if asm_instr!V_LENGTH == _2 then
 		;;; destination is a stack push
 		Get_upush_efa()
@@ -571,8 +750,10 @@
 ;;; Drop_move:
 ;;;		plant a move from a general source to a general destination.
 
-define lconstant Drop_move(_src_mod, _src_rm, _src_disp, _dst_mod, _dst_rm, _dst_disp);
+define constant Drop_move(_src_mod, _src_rm, _src_disp, _dst_mod, _dst_rm, _dst_disp);
 	lvars _src_mod, _src_rm, _src_disp, _dst_mod, _dst_rm, _dst_disp;
+;;;        _extern printf('Drop_move\n') -> _ ;
+;;;        _extern fflush(_0) -> _ ;
 	if _src_mod == _IMM then
 		Drop_move_imm(_src_disp, _dst_mod, _dst_rm, _dst_disp);
 	elseif _src_mod == _REG then
@@ -660,16 +841,20 @@
 
 	t_SGN_BYTE	= t_BYTE  || t_SIGNED,
 	t_SGN_SHORT	= t_SHORT || t_SIGNED,
+        t_SGN_INT       = t_INT   || t_SIGNED,
 	t_SGN_WORD	= t_WORD  || t_SIGNED,
 
 	;;; Opcodes for accessing fields
 
 	field_access_ops = list_assoc_val(% [%
-		t_BYTE,			[% _pint(_MOVX), _pint(_MOVZX _biclear _WBIT) %],
-		t_SHORT,		[% _pint(_MOVX), _pint(_MOVZX) %],
-		t_WORD,			[% _pint(_MOV_IN) %],
-		t_SGN_BYTE,		[% _pint(_MOVX), _pint(_MOVSX _biclear _WBIT) %],
-		t_SGN_SHORT,	[% _pint(_MOVX), _pint(_MOVSX) %],
+		t_BYTE,		[% _pint(_MOVX), _pint(_MOVZX _biclear _WBIT) %],
+		t_SHORT,	[% _pint(_MOVX), _pint(_MOVZX) %],
+                t_INT,          [% _pint(_MOVZXD) %],
+		t_WORD,		[% _pint(_MOV_IN) %],
+		t_SGN_BYTE,	[% _pint(_REX_W), _pint(_MOVX),
+                                    _pint(_MOVSX _biclear _WBIT) %],
+		t_SGN_SHORT,	[% _pint(_REX_W), _pint(_MOVX), _pint(_MOVSX) %],
+                t_SGN_INT,      [% _pint(_MOVSXD) %],
 		t_SGN_WORD,		[% _pint(_MOV_IN) %],
 	%] %),
 
@@ -677,10 +862,12 @@
 
 	field_update_ops = list_assoc_val(% [%
 		t_BYTE,			[% _pint(_MOV _biclear _WBIT) %],
-		t_SHORT,		[% _pint(_WORD), _pint(_MOV) %],
+		t_SHORT,		[% _pint(_WORD), _pint(_MOV32) %],
+                t_INT,                  [% _pint(_MOV32) %],
 		t_WORD,			[% _pint(_MOV) %],
 		t_SGN_BYTE,		[% _pint(_MOV _biclear _WBIT) %],
-		t_SGN_SHORT,	[% _pint(_WORD), _pint(_MOV) %],
+		t_SGN_SHORT,	[% _pint(_WORD), _pint(_MOV32) %],
+                t_SGN_INT,              [% _pint(_MOV32) %],
 		t_SGN_WORD,		[% _pint(_MOV) %],
 	%] %),
 
@@ -693,11 +880,13 @@
 	field_size = list_assoc_val(% [%
 		t_BYTE,			1,
 		t_SHORT,		2,
-		t_WORD,			4,
+                t_INT,                  4,
+		t_WORD,			8,
 		t_DOUBLE,		8,
 		t_SGN_BYTE,		1,
 		t_SGN_SHORT,	2,
-		t_SGN_WORD,		4,
+                t_SGN_INT,              4,
+		t_SGN_WORD,		8,
 	%] %),
 
 	;;; Index-scale codes for the possible field sizes
@@ -715,7 +904,7 @@
 ;;;		given a list of opcode bytes, plant all the prefix bytes and
 ;;;		return the opcode proper.
 
-define lconstant Drop_pfx(opcodes);
+define constant Drop_pfx(opcodes);
 	lvars opcodes;
 	until (fast_destpair(opcodes) ->> opcodes) == [] do
 		Drop_b(_int(/* prefix */));
@@ -727,7 +916,7 @@
 ;;;		checks that -structure- refers to a direct, on-stack lvar
 ;;;		and returns the appropriate offset as a sysint
 
-define lconstant stack_offset(/* structure */) with_nargs 1;
+define constant stack_offset(/* structure */) with_nargs 1;
 	lvars structure;
 	if isinteger(Trans_structure(/* structure */) ->> structure)
 	and structure fi_< 0
@@ -743,7 +932,7 @@
 ;;;		convert a vector index to an offset, i.e. convert to system integer
 ;;; 	and multiply by field size
 
-define lconstant Drop_vecsub_mult(_reg, _size);
+define constant Drop_vecsub_mult(_reg, _size);
 	lvars _reg, _size;
 	;;; sarl $2, %reg
 	Drop_std(_SHIFTI, _SAR, (_REG, _reg, false)), Drop_b(_2);
@@ -756,14 +945,14 @@
 ;;;	Drop_exptr_deref:
 ;;;		deref an external pointer -n- times
 
-define lconstant Drop_exptr_deref(exptr, _reg);
+define constant Drop_exptr_deref(exptr, _reg);
 	lvars exptr, _reg;
 	fast_repeat exptr times
 		Drop_std(_MOV_IN, _reg, Get_regindir_efa(_reg, _0))
 	endrepeat
 enddefine;
 
-define lconstant Do_bitfield(type, _size, structure, offset, upd, exptr);
+define constant Do_bitfield(type, _size, structure, offset, upd, exptr);
 	lvars type, structure, offset, upd, exptr, _size, _disp;
 	;;; Get structure address in EDI
 	if not(structure) then
@@ -812,10 +1001,13 @@
 	Drop_call_indir((_REG, _ESI, false));
 enddefine;
 
-define lconstant Do_field(type, structure, _size, offset, defer, upd, exptr);
+define constant Do_field(type, structure, _size, offset, defer, upd, exptr);
 	lvars 	ops, type, structure, offset, defer, upd, exptr,
 			_size, _reg, _disp, _n;
 
+;;;        _extern printf('Do_field\n')  -> _;
+;;;        _extern fflush(_0) -> _;
+
 	;;; Get appropriate opcode bytes for type and direction of move
 	if upd then
 		field_update_ops(type)
@@ -835,7 +1027,7 @@
 		;;; structure is in a stack lvar (from -conskey-)
 		Drop_std(_MOV_IN, _reg, Get_regindir_efa(_SP, _disp));
 	else
-		mishap(0, 'SYSTEM ERROR 1 IN Do_field');
+		mishap(structure, 1, 'SYSTEM ERROR 1 IN Do_field');
 	endif;
 	;;; If it's an external structure, get the real address
 	if exptr then
@@ -860,11 +1052,13 @@
 			;;; index is in a stack lvar (from -conskey-)
 			Drop_std(_MOV_IN, _ECX, Get_regindir_efa(_SP, _disp));
 		else
-			mishap(0, 'SYSTEM ERROR 2 IN Do_field');
+			mishap(offset, 1, 'SYSTEM ERROR 2 IN Do_field');
 		endif;
 		;;; If updating, load new value from stack to EAX
 		if upd then Drop_std(_MOV_IN, _EAX, Get_upop_efa()) endif;
 		;;; Get the size in bytes of this field type
+;;;                printf( type, 'type = %p\n');
+;;;                _extern fflush(_0) -> _;
 		field_size(type) -> _n;
 		if _size == 1 then
 			;;; Compute a displacement to be added to the index which accounts
@@ -940,7 +1134,7 @@
 ;;;		instruction. It could be a MOVE instruction (representing a push
 ;;;		not yet done) or <false> if the item is already on the stack.
 
-define lconstant Get_fsrc_efa(_arg, _tmp_reg);
+define constant Get_fsrc_efa(_arg, _tmp_reg);
 	lvars	op, _arg, _tmp_reg;
 	dlocal	asm_instr;
 	if asm_instr!INST_ARGS[_arg] ->> asm_instr then
@@ -964,7 +1158,7 @@
 ;;;		This should be a push on the user stack, but it can be optimised
 ;;;		away if there's an immediately-following POP instruction.
 
-define lconstant Get_fdst_efa();
+define constant Get_fdst_efa();
 	lvars	instr;
 	dlocal	asm_instr;
 	;;; Look out for a following POP instruction
@@ -984,7 +1178,7 @@
 ;;; Drop_fsrc:
 ;;;		move an operand of a "fast_" procedure to a register.
 
-define lconstant Drop_fsrc(_arg, _reg);
+define constant Drop_fsrc(_arg, _reg);
 	lvars _arg, _reg;
 	Drop_move(Get_fsrc_efa(_arg, _ESI), (_REG, _reg, false));
 enddefine;
@@ -994,6 +1188,8 @@
 
 define I_FASTFIELD();
 	lvars _offs;
+;;;        _extern printf('I_FASTFIELD\n') -> _;
+;;;        _extern fflush(_0) -> _;
 	Drop_fsrc(_1, _ESI);
 	if asm_instr!INST_ARGS[_0] ->> _offs then
 		_int(_offs) -> _offs;
@@ -1002,6 +1198,7 @@
 		Drop_move(Get_regindir_efa(_ESI, @@P_FRONT), Get_upush_efa());
 		@@P_BACK -> _offs;
 	endif;
+;;;        Get_regindir_efa(_ESI, _offs) -> _reg, -> _disp;
 	Drop_move(Get_regindir_efa(_ESI, _offs), Get_fdst_efa());
 enddefine;
 
@@ -1012,19 +1209,21 @@
 
 define I_FASTSUBV();
 	lvars _mod, _rm, _disp, _offs;
+;;;        _extern printf('I_FASTSUBV\n')  -> _;
+;;;        _extern fflush(_0) -> _;
 	;;; Structure in ESI
 	Drop_fsrc(_1, _ESI);
 	;;; Popint index from stack to ECX
 	Drop_std(_MOV_IN, _ECX, Get_upop_efa());
 	;;; Arg 0 is offset to first vector element (as popint)
 	;;; -- subtract popint 1 to account for base 1 subscript and popint bits
-	_int(asm_instr!INST_ARGS[_0]) _sub 1 -> _offs;
+	_int(asm_instr!INST_ARGS[_0]) _sub _14 -> _offs;
 	if (Get_fdst_efa() -> _disp -> _rm ->> _mod) == _REG then
 		;;; movl [offs](%esi, %ecx), %rm
-		Drop_extd(_MOV_IN, _rm, Get_regindir_efa(_ESI, _offs), _ECX, _s1);
+             Drop_extd(_MOV_IN, _rm, Get_regindir_efa(_ESI, _offs), _ECX, _s2);
 	else
 		;;; movl [offs](%esi, %ecx), %eax
-		Drop_extd(_MOV_IN, _EAX, Get_regindir_efa(_ESI, _offs), _ECX, _s1);
+             Drop_extd(_MOV_IN, _EAX, Get_regindir_efa(_ESI, _offs), _ECX, _s2);
 		;;; movl %eax, dst
 		Drop_std(_MOV, _EAX, (_mod, _rm, _disp));
 	endif;
@@ -1038,11 +1237,11 @@
 	Drop_std(_MOV_IN, _ECX, Get_upop_efa());
 	;;; Arg 0 is offset to first vector element (as popint)
 	;;; -- subtract popint 1 to account for base 1 subscript and popint bits
-	_int(asm_instr!INST_ARGS[_0]) _sub 1 -> _offs;
+	_int(asm_instr!INST_ARGS[_0]) _sub _14 -> _offs;
 	;;; New value from stack to EAX
 	Drop_std(_MOV_IN, _EAX, Get_upop_efa());
 	;;; movl %eax, [offs](%edi, %ecx)
-	Drop_extd(_MOV, _EAX, Get_regindir_efa(_EDI, _offs), _ECX, _s1);
+	Drop_extd(_MOV, _EAX, Get_regindir_efa(_EDI, _offs), _ECX, _s2);
 enddefine;
 
 
@@ -1112,7 +1311,7 @@
 ;;;		output an indirect jump: the target is the absolute address at the
 ;;;		given effective address
 
-define lconstant Drop_jmp_indir(_mod, _rm, _disp);
+define constant Drop_jmp_indir(_mod, _rm, _disp);
 	lvars _mod, _rm, _disp;
 	flush_USP_offset();
 	Drop_std(_BR_IND, _CHAIN, (_mod, _rm, _disp));
@@ -1125,7 +1324,7 @@
 ;;;		This always plants a long (5-byte) instruction; there's no attempt
 ;;;		to optimise short jumps.
 
-define lconstant Drop_jmp_rel(/* _offs */) with_nargs 1;
+define constant Drop_jmp_rel(/* _offs */) with_nargs 1;
 	flush_USP_offset();
 	Drop_b(_JMP);
 	Drop_l((/* _offs */ _sub _asm_code_offset) _sub _4);
@@ -1134,7 +1333,7 @@
 ;;; Drop_jcc:
 ;;;		output a conditional jump. The offset argument is as above.
 
-define lconstant Drop_jcc(_cc, _offs);
+define constant Drop_jcc(_cc, _offs);
 	lvars _cc, _offs;
 	flush_USP_offset();
 	Drop_b(_Jcc);
@@ -1157,7 +1356,8 @@
 define I_BR_std(_broffset, _arg);
 	lvars _broffset, _arg;
 	Drop_jmp_rel(_broffset);
-	Drop_b(_NOP), Drop_b(_NOP);		;;; ** Extra 2 bytes to match M-code version
+        ;;; ** Extra 4 bytes to match M-code version
+	Drop_b(_NOP), Drop_b(_NOP), Drop_b(_NOP), Drop_b(_NOP);
 enddefine;
 
 ;;; I_BR:
@@ -1181,7 +1381,7 @@
 ;;;		instruction (I_IF_opt or I_BOOL_opt). Currently, this will
 ;;;		always be I_BRCOND.
 
-define lconstant Drop_if(/* _ifso, _ifnot, */ instr) with_nargs 3;
+define constant Drop_if(/* _ifso, _ifnot, */ instr) with_nargs 3;
 	lvars instr;
 	fast_apply(/* _ifso, _ifnot, */
 		instr!INST_ARGS[_1],	;;; flag selecting appropriate condition
@@ -1318,23 +1518,26 @@
 	;;; of the jump offset table: the _17 is the length of the four
 	;;; instructions between here and the first entry in the table,
 	;;; the _4 accounts for the extra (0) entry in the table.
-	_asm_code_offset _add _17 _add _int(_ncases * 4) _add _4 -> _tabend;
+	_asm_code_offset _add _19 _add _int(_ncases * 4) _add _4 -> _tabend;
 
 	;;; If the argument was out of range, jump to after the table
 	;;; The unsigned condition accounts for both arg < 0 and arg > ncases
 	Drop_jcc(_cc_A, _tabend);	;;; 6 bytes
 
 	;;; Use the argument in EAX as an index into the jump offset table
-	;;; and load the corrseponding offset value into ECX
-	;;; The _11 is the length of the three instructions up to the table start
+	;;; and load the corresponding offset value into ECX
+	;;; The _13 is the length of the three instructions up to the table start
 	;;; and the _3 converts EAX into a sysint number of bytes.
 	;;; movl [offs](%PB, %eax), %ecx
-	@@PD_TABLE{_strsize _add _asm_code_offset _add _11 _sub _3} -> _offs;
-	Drop_extd(_MOV_IN, _ECX, (_DISP32, _PB, _offs), _EAX, _s1);	;;; 7 bytes
+	@@PD_TABLE{_strsize _add _asm_code_offset _add _13 _sub _3} -> _offs;
+        if is_large_int(_offs) then
+          mishap(0, 'I_SWITCH: OFFSET TOO BIG FOR 32-BITS');
+        endif;
+        Drop_extd(_MOVSXD, _ECX, (_DISP32, _PB, _offs), _EAX, _s1); ;;; 8 bytes
 
 	;;; Add PB to ECX to get an absolute address
 	;;; addl %PB, %ecx
-	Drop_std(_ADD, _PB, (_REG, _ECX, false));	;;; 2 bytes
+	Drop_std(_ADD, _PB, (_REG, _ECX, false));	;;; 3 bytes
 
 	;;; Go to it
 	;;; jmp *(%ecx)
@@ -1396,7 +1599,7 @@
 
 /*	Procedure Calls  */
 
-define lconstant Drop_call(on_stack, defer, _routine);
+define constant Drop_call(on_stack, defer, _routine);
 	lvars on_stack, defer, _routine;
 	;;; Get procedure in ARG_REG_0:
 	if on_stack then
@@ -1499,13 +1702,24 @@
 /*	Procedure Entry and Exit  */
 
 define I_CREATE_SF();
-	lvars	_offs;
+	lvars	_offs, _num;
 
 	;;; Set the procedure base register.
 	;;; If all is well, the procedure address should be in ARG_REG_0.
 	;;; movl %ARG_REG_0, %PB
 	Drop_std(_MOV, _ARG_REG_0, (_REG, _PB, false));
 
+        ;;; save registers
+        unless _zero(_regmask) then
+            _8 -> _num;
+            until _num == _16 do
+                if _regmask _bitst _shift(_1, _num) then
+                    Drop_short(_PUSHs, _num);
+                endif;
+                _num _add _1 -> _num;
+            enduntil;
+        endunless;
+
 	;;; Save dynamic locals
 	@@PD_TABLE -> _offs;
 	fast_repeat _pint(_Nlocals) times
@@ -1535,7 +1749,7 @@
 
 
 define I_UNWIND_SF();
-	lvars _offs;
+	lvars _offs, _num;
 
 	;;; Remove owner address and on-stack lvars
 	Drop_imm(_ARITHI, _ADDI, @@(w)[_Nstkvars _add _1], (_REG, _SP, false));
@@ -1550,10 +1764,21 @@
 		Drop_std(_POP, _0, _DISP0, _EAX, _0);
 	endrepeat;
 
+        ;;; restore registers
+        unless _zero(_regmask) then
+            _15 -> _num;
+            until _num == _7 do
+                if _regmask _bitst _shift(_1, _num) then
+                    Drop_std(_POP, _0, _REG, _num, false);
+                endif;
+                _num _sub _1 -> _num;
+            enduntil;
+        endunless;
+
 	;;; Restore procedure base register by reaching over return address
 	;;; to get the previous stack-frame owner:
 	;;; movl [4](%SP), %PB
-	Drop_std(_MOV_IN, _PB, _DISP8, _SP, _4);
+	Drop_std(_MOV_IN, _PB, _DISP8, _SP, _8);
 enddefine;
 
 
@@ -1573,9 +1798,14 @@
 	Drop_move((_ABS, _reg_ABS, ident _userhi), (_REG, _EAX, false));
 	;;; subl %USP, %eax
 	Drop_std(_SUB, _USP, (_REG, _EAX, false));
-	;;; Add in the popint bits and adjust for the stack offset
-	;;; addl $[3 - USP_offset], %eax
-	Drop_imm(_ARITHI, _ADDI, _3 _sub _USP_offset, (_REG, _EAX, false));
+	;;; Adjust for the stack offset
+;;;        Drop_imm(_ARITHI, _SUBI, _USP_offset, (_REG, _EAX, false));
+        ;;; Adjust for the word size
+        Drop_std(_SHIFTI, _SAR, (_REG, _EAX, false)), Drop_b(_1);
+        ;;; Add in the popint bits and adjust for the stack offset
+        ;;; addl $[3 - _USP_offset>>1], %eax
+	Drop_imm(_ARITHI, _ADDI, _3 _sub _shift(_USP_offset, -1),
+                      (_REG, _EAX, false));
 	;;; Push EAX
 	Drop_std(_MOV, _EAX, Get_upush_efa());
 enddefine;
